deferred class CONTAINED

feature {NONE} -- Creation

	make is
	deferred
	end
	
	make_with_name (n: like name) is
	do
		make
		set_name (n)
	end

feature -- Creation

	from_parent (p: like parent; n: like name) is
	require
		p /= Void
	do
		make
		parent := p
		if p /= Void then
			p.add_last (Current)
		end
		set_name (n)
	ensure
		parent = p
	end
	
feature -- Access

	name: STRING is
	do
		if has_name then
			Result := internal_name
		else
			Result := parent.name_of (Current)
		end
	end

	set_name (new: like name) is
	do
		if has_name then
			internal_name := new
		else
			parent.set_name_of (Current, new)
		end
	ensure
		equal (name, new)
	end

feature {NONE} -- Internal

	parent: CONTAINER[like Current]

	internal_name: STRING

	has_name: BOOLEAN is
	do
		Result := parent = Void
	end

end -- class CONTAINED
