deferred class CONTAINER[E->CONTAINED]

inherit
	LIST[E]

feature {NONE} -- Creation

	make_container is
	do
		if storage = Void then
			create storage.make_list
		end
	end

feature -- names

	name_of (e: E): STRING is
	require
		fast_has (e)
	do
		Result := storage.item (fast_index_of (e)).name
	end

	set_name_of (e: E; n: STRING) is
	require
		fast_has (e)
	do
		storage.item (fast_index_of (e)).set_name (n)
	end

feature -- Access

	count: INTEGER is
	do
		Result := storage.count
	end

	item (i: INTEGER): E is
	do
		Result := storage.item (i).item
	end

feature -- Operations

	put (e: E; i: INTEGER) is
	do
		storage.item (i).set_item (e)
	end
	
	add (e: E; i: INTEGER) is
	local
		n: CONTAINED_NODE[E]
	do
		create n.make (e, Void)
		storage.add (n, i)
	end

feature -- Removing

	remove (i: INTEGER) is
	do
		storage.remove (i)
	end

	clear is
	do
		storage.clear
	end

feature {NONE} -- Representation

	storage: ARRAYED_LIST[CONTAINED_NODE[E]]

end -- class CONTAINER
