deferred class ITEM_EQUIVALENCE[G]

feature {NONE} -- Creation

	make is
	deferred
	end

feature -- Item

	is_equal_item (other: like item): BOOLEAN is
	do
		if other = Void or item = Void then
			Result := item = Void and other = Void
		else
			Result := other.is_equal (item)
		end
	end

	from_item (b: like item) is
	require
		is_item (b)
	do
		make
		if not is_equal_item (b) then
			-- sedb_breakpoint
			set_item (b)
		end
	end

	clone_from_item (b: like item): like Current is
	require
		is_item (b)
	do
		create Result.from_item(b)
	end

	is_item (b: ANY): BOOLEAN is
	local
		i: G
	do
		i ?= b
		Result := i /= Void
	end

feature -- Void

	is_void: BOOLEAN is
	do
		Result := is_equal_item (Void)
	end

	to_void is
	do
		if not is_void then
			set_item (Void)
		end
	ensure
		is_void
	end

feature -- deferred features

	set_item (new: like item) is
	require
		not is_equal_item (new)
	deferred
	ensure
		is_equal_item (new)
	end

	item: G is
	deferred
	end

end -- class ITEM_EQUIVALENCE
