deferred class LIST_MODEL[E]

inherit
	LIST_CONSTANTS
	LIST[E]
	MODEL

feature {NONE} -- Creation

	make_list_model is
	do
		make_list
		make_model
	end

feature -- Access

	last_operation, last_row, last_row_2: INTEGER
	
feature {NONE} -- operations

	put_model (e: E; i: INTEGER) is
	do
		last_operation := op_put
		last_row := i
		notify_views
	end
	
	add_model (e: E; i: INTEGER) is
	do
		last_operation := op_add
		last_row := i
		notify_views
	end

	swap_model (i, j: INTEGER) is
	do
		last_operation := op_swap
		last_row := i
		last_row_2 := j
		notify_views
	end

feature {NONE} -- Removing

	remove_model (i: INTEGER) is
	do
		last_operation := op_remove
		notify_views
	end

	clear_model is
	do
		last_operation := op_clear
		notify_views
	end

end -- class LIST_MODEL[E]
