deferred class MODEL

feature {NONE} -- Creation

	make_model is
	do
		if views = Void then
			create views.make (1, 0)
		end
	end

feature -- Operations

	notify_views is
		-- Call `on_model_change' for all views
	local
		iter: ITERATOR[VIEW[ANY]]
	do
		from
			iter := views.get_new_iterator
		until
			iter.is_off
		loop
			iter.item.on_model_change
			iter.next
		end
	end

feature {VIEW} -- Operations

	add_view(v: VIEW[like Current]) is
		-- Add `v' as new view
	require
		not views.fast_has(v)
	do
		views.add_last(v)
	ensure
		views.fast_has(v)
	end

	remove_view(v: VIEW[like Current]) is
		-- Remove existing view `v'
	require
		views.fast_has(v)
	do
		views.remove(views.fast_index_of(v))
	ensure
		not views.fast_has(v)
	end

feature -- Representation

	views: ARRAY[VIEW[like Current]]

invariant

	views /= Void

end -- class MODEL
