deferred class STRING_EQUIVALENCE

feature {NONE} -- Creation

	make is
	deferred
	end

feature -- String

	from_string (s: STRING) is
	do
		make
		if not is_string (s) then
			to_void
		elseif not is_equal_string(s) then
			set_string (s)
		end
	end

	clone_from_string (s: STRING): like Current is
	do
		create Result.from_string (s)
	end

	is_equal_string (other: STRING): BOOLEAN is
	do
		if not is_string (other) then
			Result := is_void
		else
			Result := to_string.is_equal (other)
		end
	end

	is_string (s: STRING): BOOLEAN is
	do
		Result := s /= Void
	end

feature -- Void

	is_void: BOOLEAN is
	do
	end

	to_void is
	do
	ensure
		is_void
	end

feature -- deferred features

	set_string (s: STRING) is
	require
		is_string (s) and not is_equal_string (s)
	deferred
	ensure
		is_equal_string (s)
	end

	to_string: STRING is
	deferred
	ensure
		is_equal_string (Result)
	end

end -- class STRING_EQUIVALENCE
